/*
 * Copyright (C) 2004 by X S ( Morioka Yuichi ) .
 *
 * 2004/09/18쐬B
 */
package jp.co.infoseek.hp.streakeagle.lib.shogi;

/**
 * ǖʁiՖʁEEԁj\ύXs\ȃNXB
 * Map̃L[⃊Xg̗vfƂċǖʂ\CX^Xpꍇ́A{@link Kyokumen}NXł͂Ȃ{NXpB
 * 
 * @author X S ( Morioka Yuichi )
 * @version 1.0 
 * @since 1.0
 */
public class FixedKyokumen {
  
  public FixedKyokumen( Kyokumen kyokumen ) {
    
    
    // Ֆʂ̏Rs[
    for( int x = 1; x <= 9; x++ ) {
      
      for( int y = 1; y <= 9; y++ ) {
        
        this.banmen[ x - 1 ][ y - 1 ] = kyokumen.getMasuInfo( x, y );
        
      }// for(..y..)
      
    }// for(..x..) 
    
    
    // ̏Rs[
    for( int sente = 0; sente <= 1; sente++ ) {
      
      for( int komaType = KomaUtil.HU; komaType <= KomaUtil.HISYA; komaType++ ) {
        
        this.komadai[ sente ] [ komaType - 1 ] = kyokumen.getMochigomaNumber( sente == 0, komaType );
        
      }// for(..komaType..)
      
    }// for(..sente..)
    
    // ԏRs[
    this.teban = kyokumen.getTeban();
    
  }// FixedKyokumen(Kyokumen)
  
  
  /**
   * ՖʂێtB[hB
   */
  private final int[][] banmen = new int[ 9 ][ 9 ];
  
  
  /**
   * E̋̏ێtB[hB
   */
  private final int[][] komadai = new int [2][7]; 


  /**
   * ԂێtB[hBԂȂtrueAԂȂfalseB
   */
  private final boolean teban;
  
  
  /*
   *  ( Javadoc)
   * @see java.lang.Object#equals(java.lang.Object)
   */
  public boolean equals( Object object ) {
    
    FixedKyokumen other = ( FixedKyokumen ) object;
    
    //  Ֆʂ̏r
    for( int x = 1; x <= 9; x++ ) {
      
      for( int y = 1; y <= 9; y++ ) {
        
        if( this.banmen[ x - 1 ][ y - 1 ] !=  other.banmen[ x - 1 ][ y - 1 ] ) {
          
          return false; 
          
        }// if(...)
       
      }// for(..y..)
      
    }// for(..x..) 
    
    
    // ̏r
    for( int sente = 0; sente <= 1; sente++ ) {
      
      for( int komaType = KomaUtil.HU; komaType <= KomaUtil.HISYA; komaType++ ) {
        
        if( this.komadai[ sente ] [ komaType - 1 ] != other.komadai[ sente ][ komaType -1 ] ) {
          
         return false; 
           
        }// if(...)
        
      }// for(..komaType..)
      
    }// for(..sente..)
    
    
    // ԏr
    if( this.teban != other.teban ) {
       
      return false;
       
    }// if(...)
    
    
    // S`FbNɈȂ瓙Ɣ
    return true;
    
  }// equals(Object)

  /*
   *  ( Javadoc)
   * @see java.lang.Object#toString()
   */
  public String toString() {


    StringBuffer result = new StringBuffer();

    result.append( "----------------------------------------------------------------\n" );

    
    
    //  Ֆʂ̏ǉ

    result.append( "+---+---+---+---+---+---+---+---+---+\n" );
    
    for( int y = 1; y <= 9; y++ ) {

      result.append( '|' );

      for( int x = 9; 1 <= x; x-- ) {
 
        result.append( KomaUtil.toString( this.banmen[ x - 1 ][ y - 1 ]  ) );
        result.append( '|' );

      }// for(..y..)
      
      result.append( '\n' );
      result.append( "+---+---+---+---+---+---+---+---+---+\n" );
      
    }// for(..x..) 
    
    
    // ̏ǉ
    result.append( ",,j,,,p,\n" );
    
    for( int sente = 0; sente <= 1; sente++ ) {
      
      for( int komaType = KomaUtil.HU; komaType <= KomaUtil.HISYA; komaType++ ) {
        
          result.append( this.komadai[ sente ] [ komaType - 1 ] );
          result.append( ',' );

      }// for(..komaType..)
      
      result.deleteCharAt( result.length() - 1 );
      result.append( '\n' ); 
     
      
    }// for(..sente..)
    
    
    // ԏǉ
    result.append( " F " );
    result.append( this.teban ? "" : "" );
    result.append( '\n' );

    result.append( "----------------------------------------------------------------\n" );

    return result.toString();
    
  }// toString()


  /**   *  ( Javadoc)
   * @see java.lang.Object#hashCode()
   */
  public int hashCode() {

     //   remove for update    return this.toString().hashCode();
     
     // Ԃl(\bhŏ̂ŔzɊi[)
     int[] result = new int[ 1 ];
     
     this.fillHashCode( 2, result );
     this.fillHashCode( 8, result );
     this.fillHashCode( 3, result );
     this.fillHashCode( 7, result );
     
     
     return result[0];
     
    
  }// hashCode()

  
  /**
   * targetŎw肵ϐɁAlineŎw肵i狁߂nbVR[hi[B
   * targetɊi[ĂĺA8rbgVtgĎcB
   * 
   * @param line iB
   * @param target nbVR[hi[ϐBvf1łȂ΂ȂȂB
   * @since 1.0
   */
  private void fillHashCode( int line, int[] target ) {
     
     assert target.length == 1;
     
     // 8rbgVtg
     (target[0]) <<= 8;
     
     // 1؂8؂܂ŏ(nbVR[h̃rbg̊֌WA9؂͖)
     for( int x = 0; x < 8; x++ ) {
        
        // ΃rbg𗧂Ă
        if( this.banmen[x][line - 1] != Kyokumen.EMPTY ) {
           
           target[0] += 1;
           
        }// if(...)
        
        // 1rbgVtg
        target[0] <<= 1;
        
     }// for(...)
     
     
  }// fillHashCode(int,int[])
  
  
  public static void main( String[] args ) {
    
    System.out.println( new FixedKyokumen( new Kyokumen() )  );
    
  }// main(String[])


}// FixedKyokumen

// EOF